R: ExperimentRegistry Constructor

makeExperimentRegistry {batchtools} | R Documentation

## ExperimentRegistry Constructor

### Description

`makeExperimentRegistry` constructs a special `Registry` which is suitable for the definition of large scale computer experiments.

Each experiments consists of a `Problem` and an `Algorithm`. These can be parametrized with `addExperiments` to actually define computational jobs.

### Usage

    makeExperimentRegistry(file.dir = "registry", work.dir = getwd(),
      conf.file = findConfFile(), packages = character(0L),
      namespaces = character(0L), source = character(0L),
      load = character(0L), seed = NULL, make.default = TRUE)

### Arguments

`file.dir` | [`character(1)`] Path where all files of the registry are saved. Default is directory “registry” in the current working directory. The provided path will get normalized unless it is given relative to the home directory (i.e., starting with “~”). Note that some templates do not handle relative paths well. If you pass `NA`, a temporary directory will be used. This way, you can create disposable registries for `btlapply` or examples. By default, the temporary directory `tempdir()` will be used. If you want to use another directory, e.g. a directory which is shared between nodes, you can set it in your configuration file by setting the variable `temp.dir`.
`work.dir` | [`character(1)`] Working directory for R process for running jobs. Defaults to the working directory currently set during Registry construction (see `getwd`). `loadRegistry` uses the stored `work.dir`, but you may also explicitly overwrite it, e.g., after switching to another system. The provided path will get normalized unless it is given relative to the home directory (i.e., starting with “~”). Note that some templates do not handle relative paths well.
`conf.file` | [`character(1)`] Path to a configuration file which is sourced while the registry is created. In the configuration file you can define how batchtools interacts with the system via `ClusterFunctions`. Separating the configuration of the underlying host system from the R code allows to easily move computation to another site. The file lookup is implemented in the internal (but exported) function `findConfFile` which returns the first file found of the following candidates: File “batchtools.conf.R” in the path specified by the environment variable “R_BATCHTOOLS_SEARCH_PATH”. File “batchtools.conf.R” in the current working directory. File “config.R” in the user configuration directory as reported by `rappdirs::user_config_dir("batchtools", expand = FALSE)` (depending on OS, e.g., on linux this usually resolves to “~/.config/batchtools/config.R”). “.batchtools.conf.R” in the home directory (“~”). “config.R” in the site config directory as reported by `rappdirs::site_config_dir("batchtools")` (depending on OS). This file can be used for admins to set sane defaults for a computation site. Set to `NA` if you want to suppress reading any configuration file. If a configuration file is found, it gets sourced inside the environment of the registry after the defaults for all variables are set. Therefore you can set and overwrite slots, e.g. `default.resources = list(walltime = 3600)` to set default resources or “max.concurrent.jobs” to limit the number of jobs allowed to run simultaneously on the system.
`packages` | [`character`] Packages that will always be loaded on each node. Uses `require` internally. Default is `character(0)`.
`namespaces` | [`character`] Same as `packages`, but the packages will not be attached. Uses `requireNamespace` internally. Default is `character(0)`.
`source` | [`character`] Files which should be sourced on the slaves prior to executing a job. Calls `sys.source` using the `.GlobalEnv`.
`load` | [`character`] Files which should be loaded on the slaves prior to executing a job. Calls `load` using the `.GlobalEnv`.
`seed` | [`integer(1)`] Start seed for jobs. Each job uses the (`seed` + `job.id`) as seed. Default is a random number in the range [1, `.Machine$integer.max/2`].
`make.default` | [`logical(1)`] If set to `TRUE`, the created registry is saved inside the package namespace and acts as default registry. You might want to switch this off if you work with multiple registries simultaneously. Default is `TRUE`.

### Value

[`ExperimentRegistry`].

### Examples

    tmp = makeExperimentRegistry(file.dir = NA, make.default = FALSE)

    # Definde one problem, two algorithms and add them with some parameters:
    addProblem(reg = tmp, "p1",
      fun = function(job, data, n, mean, sd, ...) rnorm(n, mean = mean, sd = sd))
    addAlgorithm(reg = tmp, "a1", fun = function(job, data, instance, ...) mean(instance))
    addAlgorithm(reg = tmp, "a2", fun = function(job, data, instance, ...) median(instance))
    ids = addExperiments(reg = tmp, list(p1 = CJ(n = c(50, 100), mean = -2:2, sd = 1:4)))

    # Overview over defined experiments:
    tmp$problems
    tmp$algorithms
    summarizeExperiments(reg = tmp)
    summarizeExperiments(reg = tmp, by = c("problem", "algorithm", "n"))
    ids = findExperiments(prob.pars = (n == 50), reg = tmp)
    print(unwrap(getJobPars(ids, reg = tmp)))

    # Submit jobs
    submitJobs(reg = tmp)
    waitForJobs(reg = tmp)

    # Reduce the results of algorithm a1
    ids.mean = findExperiments(algo.name = "a1", reg = tmp)
    reduceResults(ids.mean, fun = function(aggr, res, ...) c(aggr, res), reg = tmp)

    # Join info table with all results and calculate mean of results
    # grouped by n and algorithm
    ids = findDone(reg = tmp)
    pars = unwrap(getJobPars(ids, reg = tmp))
    results = unwrap(reduceResultsDataTable(ids, fun = function(res) list(res = res), reg = tmp))
    tab = ljoin(pars, results)
    tab[, list(mres = mean(res)), by = c("n", "algorithm")]

[Package batchtools version 0.9.11 Index]